<template>
  <tr>
    <td>{{user.userId}}</td>
    <td>{{user.username}}</td>
    <td>{{user.email}}</td>
    <td>{{user.firstName}}</td>
    <td>{{user.lastName}}</td>
    <td>{{user.birthday}}</td>
    <td>{{user.department}}</td>
<!--    <td>{{user.role}}</td>-->
    <td v-show="user.role === 'ADMIN'"><v-icon color="yellow-darken-3">mdi-crown</v-icon></td>
    <td v-show="user.role === 'MANAGER'"><v-icon color="green-darken-3">mdi-card-account-details-star</v-icon></td>
    <td v-show="user.role === 'USER'"><v-icon color="blue-darken-4">mdi-card-account-details</v-icon></td>
    <td>
      <v-btn
          v-if="authStore.user.role === 'ADMIN'"
          size="small"
          color="red-accent-4"
          @click="deleteUser"
      ><v-icon small>mdi-delete</v-icon></v-btn>
      <v-btn
          v-if="authStore.user.role === 'MANAGER' && authStore.user.department === user.department"
          size="small"
          color="red-accent-4"
          @click="deleteUser"
      ><v-icon small>mdi-delete</v-icon></v-btn>

      <edit-user-dialog
          v-if="authStore.user.role === 'ADMIN'"
          :page="page"
          :user="user"></edit-user-dialog>
      <v-btn
          size="small"
          color="blue-darken-4" @click="userDetails"><v-icon>mdi-information-outline</v-icon></v-btn>
    </td>
  </tr>




  <!--  DIALOG-->
  <v-dialog v-model="dialog">
    <v-card class="align-center">
      <v-card-title>
        Löschen
      </v-card-title>
      <v-card-text>
        Bist du sicher, dass du User {{props.user.lastName}} {{props.user.userId}} löschen willst??
      </v-card-text>
      <v-card-actions>
        <v-btn color="green-darken-3" text @click="confirmDelete">Ja</v-btn>
        <v-btn color="red-accent-4" text @click="dialog = false">Abbrechen</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup>

import {useAuthStore} from "@/stores/authStore";
import {useUserStore} from "@/stores/userStore";
import {ref} from "vue";
import EditUserDialog from "@/components/dialogs/EditUserDialog.vue";
import {router} from "@/router";

//STORES
const authStore = useAuthStore();
const userStore =useUserStore();

//PROPS
const props = defineProps(['user', 'page'])
let dialog = ref(false);

//FUNCTIONS
async function deleteUser() {
  dialog.value = true;
}
async function confirmDelete() {
  try {
    dialog.value = false;
    await userStore.deleteUser(props.user.userId);
    await userStore.getUsers(props.page)

  } catch (error) {
    alert("Du kannst den User nicht löschen!");
    console.log(error)
  }
}

function userDetails() {
  router.push({ name: "SingleEmployeeView", params: { id: props.user.userId } });
}

</script>

<style scoped>
</style>